"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var useMediaQuery_1 = tslib_1.__importDefault(require("../useMediaQuery"));
var useStorage_1 = require("../useStorage");
function useDarkMode(token) {
    if (token === void 0) { token = "dark-mode"; }
    var _a = (0, useStorage_1.useLocalStorage)("useDarkMode"), darkMode = _a[0], setDarkMode = _a[1];
    var prefersDarkMode = (0, useMediaQuery_1.default)("(prefers-color-scheme: dark)");
    var enabled = !!(darkMode !== null && darkMode !== void 0 ? darkMode : prefersDarkMode);
    (0, react_1.useEffect)(function () {
        document.body.classList.toggle(token, enabled);
    }, [enabled]);
    return [enabled, setDarkMode];
}
exports.default = useDarkMode;
