"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSessionStorage = exports.useLocalStorage = void 0;
var react_1 = require("react");
function useStorage(key, defaultValue, storage) {
    var storageObject = window[storage];
    var _a = (0, react_1.useState)(function () {
        var jsonValue = storageObject.getItem(key);
        if (jsonValue !== null)
            return JSON.parse(jsonValue);
        if (typeof defaultValue === "function") {
            return defaultValue();
        }
        else {
            return defaultValue;
        }
    }), value = _a[0], setValue = _a[1];
    (0, react_1.useEffect)(function () {
        if (value === undefined) {
            storageObject.removeItem(key);
        }
        else {
            storageObject.setItem(key, JSON.stringify(value));
        }
    }, [key, value, storageObject]);
    var remove = (0, react_1.useCallback)(function () {
        setValue(undefined);
    }, []);
    return [value, setValue, remove];
}
exports.default = useStorage;
function useLocalStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "localStorage");
}
exports.useLocalStorage = useLocalStorage;
function useSessionStorage(key, defaultValue) {
    return useStorage(key, defaultValue, "sessionStorage");
}
exports.useSessionStorage = useSessionStorage;
